## ros-noetic-iris-lama 1.3.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
project(iris_lama LANGUAGES CXX C)

set(IRIS_LAMA_VERSION 1.3.1)

# provides default CMAKE_INSTALL_<dir> variables
include(GNUInstallDirs)
# helpers to generate <package>Config.cmake
include(CMakePackageConfigHelpers)

# install location of generated cmake config files
set(ConfigPackageLocation ${CMAKE_INSTALL_LIBDIR}/${CMAKE_PROJECT_NAME}/cmake)

# dependencies
find_package(Eigen3 3.3 REQUIRED NO_MODULE)

# the code
add_subdirectory(src)

# libs and binaries, generate export targets
install(TARGETS iris_lama
  EXPORT ${CMAKE_PROJECT_NAME}Targets
  ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

# header files, note the "/" after include
install(DIRECTORY include/
  DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})

# for build tree / in workspace
export(EXPORT ${CMAKE_PROJECT_NAME}Targets
  FILE ${CMAKE_CURRENT_BINARY_DIR}/${CMAKE_PROJECT_NAME}Targets.cmake
  NAMESPACE ${CMAKE_PROJECT_NAME}::)
# exported targets
install(EXPORT ${CMAKE_PROJECT_NAME}Targets
  FILE ${CMAKE_PROJECT_NAME}Targets.cmake
  NAMESPACE ${CMAKE_PROJECT_NAME}::
  DESTINATION ${ConfigPackageLocation})

# generate package version file
write_basic_package_version_file(
  ${CMAKE_CURRENT_BINARY_DIR}/${CMAKE_PROJECT_NAME}ConfigVersion.cmake
  VERSION ${IRIS_LAMA_VERSION}
  COMPATIBILITY SameMajorVersion)

# generate package configuration file
set(INCLUDE_INSTALL_DIR ${CMAKE_INSTALL_INCLUDEDIR})
configure_package_config_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/cmake/${CMAKE_PROJECT_NAME}Config.cmake.in
  ${CMAKE_CURRENT_BINARY_DIR}/${CMAKE_PROJECT_NAME}Config.cmake
  INSTALL_DESTINATION ${ConfigPackageLocation}
  PATH_VARS INCLUDE_INSTALL_DIR)

# install the package configuration files
install(FILES
  ${CMAKE_CURRENT_BINARY_DIR}/${CMAKE_PROJECT_NAME}Config.cmake
  ${CMAKE_CURRENT_BINARY_DIR}/${CMAKE_PROJECT_NAME}ConfigVersion.cmake
  DESTINATION ${ConfigPackageLocation})

=== src/CMakeLists.txt ===

set(lama_SOURCES
    # Base
    buffer_compressor.cpp
    graph_slam2d.cpp
    image_io.cpp
    loc2d.cpp
    match_surface_2d.cpp
    pf_slam2d.cpp
    print.cpp
    pose2d.cpp
    pose3d.cpp
    random.cpp
    slam2d.cpp
    thread_pool.cpp

    # Non-Linear Least Squares Optimization
    nlls/gauss_newton.cpp
    nlls/levenberg_marquardt.cpp
    nlls/robust_cost.cpp
    nlls/solver.cpp

    # Sparse-Dense Mapping
    sdm/container.cpp
    sdm/dynamic_distance_map.cpp
    sdm/export.cpp
    sdm/frequency_occupancy_map.cpp
    sdm/map.cpp
    sdm/marching_cubes.cpp
    sdm/probabilistic_occupancy_map.cpp
    sdm/simple_occupancy_map.cpp
    sdm/truncated_signed_distance_map.cpp
)

# vendor (or third party) software
add_subdirectory(../vendor/lz4      vendor/lz4)
add_subdirectory(../vendor/minisam  vendor/minisam)
add_subdirectory(../vendor/zstd     vendor/zstd)

add_library(iris_lama ${lama_SOURCES}
    $<TARGET_OBJECTS:lz4>
    $<TARGET_OBJECTS:minisam>
    $<TARGET_OBJECTS:zstd>
)

target_include_directories(iris_lama
    PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/../include>
    $<INSTALL_INTERFACE:include>

    PRIVATE
    ../vendor/lz4
    ../vendor/minisam
    ../vendor/moodycamel
    ../vendor/nanoflann
    ../vendor/stb
    ../vendor/zstd
)

target_compile_features(iris_lama PUBLIC cxx_std_14)
target_compile_options(iris_lama PRIVATE -Wall -Wextra)

if (${CMAKE_SYSTEM_PROCESSOR} MATCHES "arm")
    target_compile_options(iris_lama PRIVATE -faligned-new)
endif()

target_link_libraries(iris_lama PUBLIC pthread Eigen3::Eigen)
target_include_directories(iris_lama PRIVATE extern/minisam)

=== vendor/lz4/CMakeLists.txt ===
add_library(lz4 OBJECT lz4/lz4.c)

=== vendor/minisam/CMakeLists.txt ===
set(minisam_SRC
    minisam/core/Factor.cpp
    minisam/core/FactorGraph.cpp
    minisam/core/Key.cpp
    minisam/core/LossFunction.cpp
    minisam/core/SchurComplement.cpp
    minisam/core/VariableOrdering.cpp
    minisam/core/Variables.cpp
    minisam/utils/testAssertions.cpp
    minisam/utils/Timer.cpp
    minisam/linear/ConjugateGradient.cpp
    minisam/linear/Covariance.cpp
    minisam/linear/DenseCholesky.cpp
    minisam/linear/SchurComplementDenseSolver.cpp
    minisam/linear/SparseCholesky.cpp
    minisam/linear/SquareRootCholesky.cpp
    minisam/nonlinear/DoglegOptimizer.cpp
    minisam/nonlinear/GaussNewtonOptimizer.cpp
    minisam/nonlinear/LevenbergMarquardtOptimizer.cpp
    minisam/nonlinear/linearization.cpp
    minisam/nonlinear/MarginalCovariance.cpp
    minisam/nonlinear/NonlinearOptimizer.cpp
    minisam/nonlinear/NumericalFactor.cpp
    minisam/nonlinear/SparsityPattern.cpp
)

add_library(minisam OBJECT ${minisam_SRC})
target_link_libraries(minisam PRIVATE Eigen3::Eigen)

=== vendor/zstd/CMakeLists.txt ===

set(zstd_SRC
    zstd/debug.c
    zstd/entropy_common.c
    zstd/error_private.c
    zstd/fse_compress.c
    zstd/fse_decompress.c
    zstd/hist.c
    zstd/huf_compress.c
    zstd/huf_decompress.c
    zstd/pool.c
    zstd/threading.c
    zstd/xxhash.c.inc
    zstd/zstd_common.c
    zstd/zstd_compress.c
    zstd/zstd_ddict.c
    zstd/zstd_decompress.c
    zstd/zstd_double_fast.c
    zstd/zstd_fast.c
    zstd/zstd_lazy.c
    zstd/zstd_ldm.c
    zstd/zstdmt_compress.c
    zstd/zstd_opt.c
)

add_library(zstd OBJECT ${zstd_SRC})

=== debian/changelog ===
ros-noetic-iris-lama (1.3.1-1focal) focal; urgency=high

  * Fix armhf compilation

 -- Eurico Pedrosa <efp@ua.pt>  Thu, 01 Sep 2022 23:00:00 -0000

ros-noetic-iris-lama (1.3.0-1focal) focal; urgency=high

  * Switch to plain cmake instead of a catkin based
  * Several performance improvements
  * Add a 2D slam solution based on pose graph optimization
  * Add read support for more image types thanks to stb_image.h
  * Add IO to the map data structure
  * Introduce transient mapping to slam2d
  * Reduce memory usage of the dynamic distance map by ~30%
  * Fix a bug where some cells in the dynamic distance map were not update correctly

 -- Eurico Pedrosa <efp@ua.pt>  Wed, 31 Aug 2022 23:00:00 -0000

ros-noetic-iris-lama (1.2.0-1focal) focal; urgency=high

  * Expose localization covariance

 -- Eurico Pedrosa <efp@ua.pt>  Fri, 09 Apr 2021 23:00:00 -0000

ros-noetic-iris-lama (1.1.0-1focal) focal; urgency=high

  * Expose the global localization parameters as options
  * Add option to mark free cells when there is no hit in SLAM (i.e. truncated ranges)
  * Add non-motion update trigger to location
  * Fix infinite loop in global localization
  * Use C++14
  * Fix eigen aligment issues

 -- Eurico Pedrosa <efp@ua.pt>  Sat, 05 Dec 2020 00:00:00 -0000

ros-noetic-iris-lama (1.0.0-1focal) focal; urgency=high

  * First official release.

 -- Eurico Pedrosa <efp@ua.pt>  Mon, 04 May 2020 23:00:00 -0000

=== debian/control ===
Source: ros-noetic-iris-lama
Section: misc
Priority: optional
Maintainer: Eurico Pedrosa <efp@ua.pt>
Build-Depends: debhelper (>= 9.0.0), cmake, libeigen3-dev
Homepage: 
Standards-Version: 3.9.2

Package: ros-noetic-iris-lama
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, 
Description: IRIS package for Localization and Mapping (LaMa).
 This packages includes the sparse-dense library for grid mapping, a 2D localization algorithm based on scan matching, an online SLAM solution with a dynamic likelihood field and a 2D RB Particle Filter SLAM solution with multithreading.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/noetic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
endif

# Solve shlibdeps errors in REP136 packages that use GNUInstallDirs:
export DEB_HOST_MULTIARCH := $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/noetic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/noetic" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-noetic-iris-lama//opt/ros/noetic/lib/:$(CURDIR)/debian/ros-noetic-iris-lama//opt/ros/noetic/lib/${DEB_HOST_MULTIARCH}

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_install
